Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports System
Imports System.collections
Imports ThinkGeo.MapSuite.Core

Namespace WellLabelTextStyle

    Public Class WellLabelTextStyle
        Inherits TextStyle

        Protected Overloads Overrides Sub DrawCore(ByVal features As IEnumerable(Of Feature), ByVal canvas As GeoCanvas, ByVal labelsInThisLayer As Collection(Of SimpleCandidate), ByVal labelsInAllLayers As Collection(Of SimpleCandidate))

            Dim fontSize As Double = Math.Sqrt(canvas.Height / canvas.CurrentWorldExtent.Height) / 2
            Dim well_label_size As Single = 1

            fontSize = fontSize * well_label_size

            If fontSize < 5 Then Exit Sub
            If fontSize > 20 Then fontSize = 20

            Dim fnt As New GeoFont("Verdana", fontSize)
            Dim br As GeoBrush
            br = New GeoSolidBrush(New GeoColor(0, 0, 0))

            For Each feature As Feature In features
                If Not feature.Tag Is Nothing Then
                    Dim ele() As String = Split(feature.Tag, " ")
                    Dim ele2() As String = Split(ele(UBound(ele)), "-")
                    Dim textstring As String = ""
                    If fontSize < 7 Then
                        textstring = ele2(UBound(ele2))
                    ElseIf fontSize < 9 AndAlso UBound(ele2) > 0 Then
                        textstring = ele2(UBound(ele2) - 1) + "-" + ele2(UBound(ele2))
                    ElseIf fontSize < 12 Then
                        textstring = ele(UBound(ele))
                    Else
                        textstring = feature.Tag
                    End If

                    If TypeOf (canvas) Is PrinterGeoCanvas Then
                        canvas.DrawTextWithWorldCoordinate(textstring, fnt, br, _
                            feature.GetBoundingBox.GetCenterPoint.X, _
                            feature.GetBoundingBox.GetCenterPoint.Y - ((fontSize + 4) _
                            * canvas.CurrentWorldExtent.Height / canvas.Height), _
                            ThinkGeo.MapSuite.Core.DrawingLevel.LabelLevel)
                    Else
                        canvas.DrawTextWithWorldCoordinate(textstring, fnt, br, _
                            feature.GetBoundingBox.GetCenterPoint.X, _
                            feature.GetBoundingBox.GetCenterPoint.Y - ((fontSize + 4) _
                            * canvas.CurrentWorldExtent.Height / canvas.Height), _
                            ThinkGeo.MapSuite.Core.DrawingLevel.LabelLevel)
                    End If

                End If
            Next
        End Sub

        Protected Overloads Overrides Function GetRequiredColumnNamesCore() As System.Collections.ObjectModel.Collection(Of String)
            Dim columns As New Collection(Of String)()
            If Not columns.Contains(TextColumnName) Then
                columns.Add(TextColumnName)
            End If
            Return columns
        End Function
    End Class
End Namespace